#!/usr/bin/env python3
# KeepeeUpee by Mike Cook

from gpiozero import Button
import pygame
import time, random
from apa102bang import Apa102bang

def main():
  global beam,gameOn,ballHeight,ballCol
  print("KeepeeUpee")
  init()
  gameOn = True ; yourScore = 0 
  bombHit = False; ballHeight = 1 
  foot = 0
  leds.setLed(0,footCol[foot]) # foot colour
  leds.show()
  time.sleep(gameSpeed)
  nextBallMove = time.time()+gameSpeed
  while 1:
    while gameOn:
      if time.time()>nextBallMove:
         leds.setLed(ballHeight,(0,0,0))
         ballHeight +=ballDirection  
         leds.setLed(ballHeight,ballCol)
         nextBallMove = time.time()+gameSpeed
      yourScore = fireBeam(ballHeight,yourScore)
      if ballHeight == 1 :
          leds.setAll((0,0,0))
          leds.setLed(0,(255,0,0))
          leds.show()
          time.sleep(2.5) # time to play
          hits -= 1
          if hits == 0:
            gameOn = False
          else:
            leds.setLed(0,footCol[foot])
            setBombCol()
            ballHeight = 1
      leds.show()
    print("Ball missed your score",yourScore)
    while kick.is_pressed:
        pass
    time.sleep(gameSpeed* 5)         
    print("Press kick for a new game")
    while not(kick.is_pressed):
        pass
    hits = 3
    gameOn = True
    ballHeight = 1
    ballDirection = 1
    leds.show()
    setBallCol()
    while kick.is_pressed:
        pass
   
def init():
   global kick,ball,leds,gameSpeed,footCol,gameSound
   random.seed()
   kick = Button(4)
   length = 8 ; brightness = 4
   dataPin = 23 ; clockPin = 24 # Blinkt wiring
   leds = Apa102bang(length,dataPin,clockPin,brightness)
   gameSpeed = 0.3 # step speed of game
   pygame.mixer.quit()
   pygame.mixer.init(frequency=22050, size=-16, channels=2, buffer=512)   
   footCol = [(0,16,16),(128,128,128),(0,128,128)] # foot colours
   soundEffects = ["ComputerBeeps2","Laser1","Pop","Screech"]
   gameSound = [ pygame.mixer.Sound("sounds/"+soundEffects[sound]+".wav")
                  for sound in range(0,4)]


        
# Main program logic:
if __name__ == '__main__':    
    main()
