#!/usr/bin/env python
# Old McDonnold's Farm card enrolling - by Mike Cook
 
from rc522rfid import Rc522rfid
import pygame, time, os

pygame.init()                   # initialise graphics interface
os.environ['SDL_VIDEO_WINDOW_POS'] = 'center'
pygame.display.set_caption("Old McDonald's Farm Enroll")
pygame.event.set_allowed(None)
pygame.event.set_allowed([pygame.KEYDOWN,pygame.QUIT])
screenWidth = 723 ; screenHeight = 369
screen = pygame.display.set_mode([screenWidth,screenHeight],0,32)
pygame.key.set_repeat(500, 20)

rfidReader = Rc522rfid()
needsRedraw = True
enroll = False
seeAll = False

def main():
   global xPlot,yPlot,done,enroll,needsRedraw,currentA,currentType
   print ("Old McDonald's Farm - Enrolling Cards")
   print ("Space - poistion next animal, cursor keys to move animals")
   print ("a - toggle seeAll animals, Return to change animal,  e - Enroll card")
   init()
   drawScreen(0,0)
   while 1:
      checkForEvent()
      for i in range(0,len(animalNames)):
         currentType = i
         done = False
         needsRedraw = True
         while not done:
           checkForEvent()    
           if needsRedraw:  
             drawScreen(i,currentA)
         if enroll :
            enroll = False
            print("enrolling")
            enrollCard(animalNames[i])
     
def drawScreen(cType,Cindex):
   global needsRedraw
   pygame.draw.rect(screen,(255,255,255),(0,0,screenWidth,screenHeight),0)
   screen.blit(farmBuilding,(0,0))
   if seeAll:
      for j in range(0,len(animalNames)):
         for i in range(0,5):
            screen.blit(animalPictures[j],(xPlot[j][i],yPlot[j][i]))
   else:   
      for i in range(0,5):
         screen.blit(animalPictures[cType],(xPlot[cType][i],yPlot[cType][i]))
   screen.blit(farmFence,(0,270))
   pygame.display.update()
   needsRedraw = False

def init():
   global animalNames,animalPictures,farmBuilding,farmFence,animalTypesNumber
   global xPlot,yPlot,currentType,currentA
   path = os.path.realpath(__file__) 
   path = os.path.dirname(path) + "/farmPictures/"
   #get a list of files
   animalNames = [fn for fn in next(os.walk(path))[2]]
   list.sort(animalNames) # put in alphabetical order
   animalTypesNumber = len(animalNames)
   print("you have these animals\n",animalNames)
   animalPictures= [ pygame.image.load("farmPictures/"+animalNames[i]).convert_alpha()
                  for i in range(0,len(animalNames))]
   farmBuilding = pygame.image.load("farmPictures/fixed/farm.png").convert_alpha()
   farmFence = pygame.image.load("farmPictures/fixed/fence.png").convert_alpha()
   xPlot = [ [144,144,144,144,144] for i in range(0,len(animalNames))] 
   yPlot = [ [200,200,200,200,200] for i in range(0,len(animalNames))]
   currentType = 0 ; currentA = 0

         
def enrollCard(name):
   print("Enroling", name, "place a card on the reader")
   data1 = [] ; data2 = [] ; data3 = []
   for i in range(0,16): # fill with a sectors worth of zeros
      data1.append(0) ; data2.append(0) ; data3.append(0)
   for i in range(0,len(name)):
      data1[i] = ord(name[i])
   #save position of these animals
   k = 0   
   for i in range(0,4):
      data2[k] = xPlot[currentType][i] >> 8
      data2[k+1] = xPlot[currentType][i] & 0xFF         
      data2[k+2] = yPlot[currentType][i] >> 8         
      data2[k+3] = yPlot [currentType][i] & 0xFF
      k+=4
   data3[0] = xPlot[currentType][4] >> 8
   data3[1] = xPlot[currentType][4] & 0xFF         
   data3[2] = yPlot[currentType][4] >> 8         
   data3[3] = yPlot [currentType][4] & 0xFF     
   # This is the (default) key for authentication
   key = [0xFF,0xFF,0xFF,0xFF,0xFF,0xFF]
   rfidReader.RC522_WriteSector(key,12,data1)
   rfidReader.RC522_WriteSector(key,13,data2)
   rfidReader.RC522_WriteSector(key,14,data3)
   print("finished enrolling\n")

def terminate(): # close down the program
    print ("Closing down please wait")
    pygame.mixer.quit()
    pygame.quit() # close pygame
    os._exit(1)
 
def checkForEvent(): # see if we need to quit
    global xPlot,yPlot,needsRedraw,done,enroll,currentA,currentType,seeAll
    event = pygame.event.poll()
    if event.type == pygame.QUIT :
         terminate()
    if event.type == pygame.KEYDOWN :
       if event.key == pygame.K_ESCAPE :
          terminate()
       if event.key == pygame.K_RETURN :
          currentA += 1
          if currentA >= 5:
             currentA = 0
          enroll = False          
       if event.key == pygame.K_SPACE :
          done = True
          enroll = False
       if event.key == pygame.K_e :
          done = True
          enroll = True
       if event.key == pygame.K_a :
          seeAll = not seeAll
          needsRedraw = True
       if event.key == pygame.K_UP :
          yPlot[currentType][currentA] -= 1
          needsRedraw = True
       if event.key == pygame.K_DOWN :
          yPlot[currentType][currentA] += 1
          needsRedraw = True
       if event.key == pygame.K_RIGHT :
          xPlot[currentType][currentA] += 1
          needsRedraw = True
       if event.key == pygame.K_LEFT :
          xPlot[currentType][currentA] -= 1
          needsRedraw = True
       if event.key == pygame.K_s :
          print(xPlot[currentType][currentA],yPlot[currentType][currentA])
     
# Main program logic:
if __name__ == '__main__':
    main()

            
