#!/usr/bin/env python
# Simple RFID Jukebox by Mike Cook
 
from rc522rfid import Rc522rfid
import pygame

pygame.mixer.quit()
pygame.mixer.init(frequency=22050, size=-16, channels=2, buffer=512)   
rfidReader = Rc522rfid()
tokens = [0xf6690ebb,0xcb3aa4d5,0x9c35fddd,0x8cd32dde,0xc682ade,0x1cb413de]
files = [ "Drum","DrumMachine","DrumSet1","DrumSet2","Eggs","DripDrop" ]

def main():
   print ("Simple RFID Jukebox player")
   print ("Press Ctrl-C to stop.")
   while 1: # repeat forever    
      cardNumber = rfidReader.RC522_GetCard()
      pygame.mixer.music.stop()
      for i in range(0,len(tokens)):
         if cardNumber == tokens[i]:
            try :
                pygame.mixer.music.load("/home/pi/Music/"+str(files[i])+".mp3")
                pygame.mixer.music.play()
                print("Playing:- "+str(files[i])+".mp3")
            except :
                print("No file:-/home/pi/Music/"+str(files[i])+".mp3")
               
# Main program logic:
if __name__ == '__main__':
  try:
    main()
  except KeyboardInterrupt:
    pass

            
